/*
 * eff.c
 *
 * Created: 27.10.2017 12:47:43
 *  Author: dsosnowski
 */ 

#define F_CPU 8000000UL
#include <avr/io.h>
#include <inttypes.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include "ledLine.h"
#include "eff.h"



//----------------------------------------------------------
void NightRider(void){
	static uint8_t next = 0;
	static uint8_t dir = 0;
	
	if (dir == 0){
		next++;
	} else {
		next--;
	}

	if (next >= (LINE_LEN - 1)) {
		dir = 1;
	}
	if (next == 0) {
		dir = 0;
	}

	LineDotSet(next);
	
}

//----------------------------------------------------------
void Sopel(void){
	static uint8_t next = 0;

	next++;
	if (next >= (LINE_LEN * 2)) {
		next = 0;
	}

	LineDotSet(next);
}


//----------------------------------------------------------
void SopelBack(void){
	static uint8_t next = 0;

	next--;
	if (next >= (LINE_LEN * 2)) {
		next = (LINE_LEN * 2);
	}

	LineDotSet(next);
}

//----------------------------------------------------------
void NightRider2(void){
	static uint8_t next = 0;
	static uint8_t dir = 0;
	
	if (dir == 0){
		next++;
	} else {
		next--;
	}

	if (next >= (LINE_LEN*2)) {
		dir = 1;
	}
	if (next == 0) {
		dir = 0;
	}
	if (next < 6) LineDotSet(0);
	else if (next > 18) LineDotSet(11);
	else LineDotSet(next - 6);
	
}

//----------------------------------------------------------
void SopelSlow(void){
	static uint8_t next = 0;

	next++;
	if (next >= (LINE_LEN * 4)) {
		next = 0;
	}

	LineDotSet(next);
}

//----------------------------------------------------------
void SopelBackSlow(void){
	static uint8_t next = 0;

	next--;
	if (next >= (LINE_LEN * 4)) {
		next = (LINE_LEN * 4);
	}

	LineDotSet(next);
}

//----------------------------------------------------------
void RandomPoints(void){
	uint8_t next = (TCNT0 % LINE_LEN);

	LineDotSet(next);
}

//----------------------------------------------------------
void RandomSopel(void){
	static uint8_t noth = 0;
	static uint8_t next = 0;
	static uint8_t dir = 0;	
	
	
	if (next >= LINE_LEN){
		noth++;
		if (noth > 6){
			next = (TCNT0 % LINE_LEN);
			dir = (next & 1);
			if (next < 6) 
				dir = 0;
			else
				dir = 1;	
			
		} 
	} else {
		noth = 0;
		if (dir == 0){
			next++;
		} else {
			next--;
		}
	}

	LineDotSet(next);
}